<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2007 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.7 - Last modified 5/21/2007
*/


error_reporting (E_ALL ^ E_NOTICE);

define ('BOOT', 1);
$cfg = array();

// Debug prevents deletion of work files
$debug = 0;


// Language determination
$language = 'english';
if (isset ($_POST['langs'])) {
	$language = $_POST['langs'];
} elseif (isset ($_GET['langs'])) {
	$language = $_GET['langs'];
}
$url_language = urlencode ($language); // For GET method


// Custom installer functions
function make_new_file($path, $data = '') {
	if (file_exists ($path)) {
		return TRUE;
	}
	$fp = @fopen ($path, 'w');
	if (!$fp) {
		web_line('Could not create file &ldquo;'.$path.'&rdquo');
		return FALSE;
	}
	if (!empty ($data)) {
		fwrite ($fp, $data, strlen ($data));
	}
	fclose ($fp);
	return TRUE;
}


// Begin installer
include('common.php');
include('language/'.$language.'.php');


// *** BEGIN HTML ***
echo <<<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title>$langop_install_title</title>

	<meta http-equiv="Content-Type" content="text/html; charset=$charset">

	<link rel="stylesheet" type="text/css" href="templates/Install.css" title="Installer">
</head>
<body>


EOF;


// Startup tests
$errs = array();
if (!is_writable('.')) {
	$errs[] = "You need to CHMOD your main directory so it is writable (use 777 if you are not sure what to use).";
}
if (!is_writable('./templates')) {
	$errs[] = "You need to CHMOD the templates directory so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('./resource') && (!is_writable ('./resource'))) {
	$errs[] = "The resource folder is present but not writable.  CHMOD it so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('./pictures') && (!is_writable ('./pictures'))) {
	$errs[] = "The pictures folder is present but not writable.  CHMOD it so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('./avatars') && (!is_writable ('./avatars'))) {
	$errs[] = "The avatars folder is present but not writable.  CHMOD it so it is writable (use 777 if you are not sure what to use).";
}
if (file_exists ('config.php') && (!is_writable ('config.php'))) {
	$errs[] = "The config file is not writable.  CHMOD it as defined in &ldquo;readme.html&rdquo; or delete the file if you are re-installing the board.";
}
if (file_exists ('dbconn.php') && (!is_writable ('dbconn.php'))) {
	$errs[] = "The database config file is not writable.  CHMOD it as defined in &ldquo;readme.html&rdquo; or delete the file if you are re-installing the board.";
}
$errs_count = count ($errs);
if ($errs_count > 0) {
	for ($i = 0; $i < $errs_count; $i++) {
		echo ("<p>{$errs[$i]}</p>\n\n");
	}
echo <<<EOF
</body>
</html>
EOF;
//<?
	exit;
}


// Confirmation for delete database
if ($_GET['mode'] == 'del') {
echo <<<EOF
	<h1 class="title">
		$langop_delete_dbase
	</h1>

	<hr />



EOF;
//<?

	if (file_not_empty('dbconn.php') && file_not_empty('config.php')) {
		include('config.php');

		if (empty ($cfg['op_title'])) {
			$cfg['op_title'] = '[ Unnamed, Data Prefix="'.$OekakiPoteto_Prefix.'", Member Prefix="'.$OekakiPoteto_MemberPrefix.'" ]';
		}

echo <<<EOF
	<h2 class="header">
		$langop_Uninstall_prompt
	</h2>

	<div class="infotable">
		<p class="infonote">
			$langop_sure_remove_dbase &ldquo;{$cfg['op_title']}&rdquo;.  $langop_all_delete <br />
			<br />
			$langop_delete_oneboard<br />
			<br />
			$langop_sharing_dbase<br />
			<br />
			$langop_remove_board
		</p>

		<form action="install.php" method="post" class="infonote">
			<input name="action" type="hidden" value="db_delete" />
			<input name="langs" type="hidden" value="{$language}" />

			<input name="db_prefix" type="checkbox" /> $langop_delepostcomm <br />
			<input name="db_members" type="checkbox" /> $langop_delememp <br />
			<br />
			<input name="submit" type="submit" value="$langop_word_delete" />
		</form>
	</div>
</body>
</html>
EOF;
//<?

		exit;

	} else {

echo <<<EOF
	<h2 class="header">
		$langop_uninserror
	</h2>

	<div class="infotable">
		<p class="infonote">
			$langop_uninsmsg
		</p>
	</div>
</body>
</html>
EOF;
//<?

		exit;
	}
}


// Delete database
//
if ($_POST['action'] == 'db_delete') {
	include('dbconn.php');
	include('config.php');
	$delete_flag = 0;

echo <<<EOF
	<h1 class="title">
		$langop_delete_dbase
	</h1>

	<hr />


	<h2 class="header">
		$langop_unistatus
	</h2>

	<div class="infotable">
		<p>

EOF;
//<?

	if ($_POST['db_prefix'] != '' && !$debug) {
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_Prefix}oekakicmt");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_Prefix}oekakidta");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_Prefix}oekakimisc");
		sql_check($result);

		$delete_flag = 1;
	}

	if ($_POST['db_members'] != '' && !$debug) {
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekaki");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakichat");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakichatmod");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakichatmodusers");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakionline");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakikill");
		sql_check($result);
		$result = mysql_query ("DROP TABLE {$OekakiPoteto_MemberPrefix}oekakimailbox");
		sql_check($result);

		$delete_flag = 1;
	}

	mysql_close($dbconn);
?>
		</p>

<? if ($delete_flag == 1) { ?>
		<p>
			<?=$langop_install_dbremove?> 
		</p>
<? } else { ?>
		<p>
			<?=$langop_notedbchange?>
		</p>
<? } ?>

		<p>
			<a href="install.php?langs=<?=$url_language?>"><?=$langop_returninst?></a>
		</p>
	</div>

</body>
</html>
<?
	exit;
}


//
// User submits information (Yes, this is different from the control panel)
if ($_POST['action'] == 'process') {
	// Check all posts
	foreach ($_POST as $key=>$value) {
		$_POST[$key] = trim (slashit ($_POST[$key]));
	}


echo <<<EOF
	<h1 class="title">
		$langop_wacinstall
	</h1>

	<hr />


	<h2 class="header">
		$langop_instalprog
	</h2>

	<div class="infotable">
		<p>

EOF;
//<?


	// Verify input
	$OekakiPoteto_Prefix = $_POST['dbprefix'];
	$OekakiPoteto_MemberPrefix = $_POST['OekakiPoteto_MemberPrefix'];
	$pass    = $_POST['pass'];
	$pass2   = $_POST['pass2'];
	$salt    = $_POST['salt'];
	$usrname = $_POST['usrname'];

	$input_fail = 0;
	if (empty ($_POST['dbhost']) || empty ($_POST['dbuser']) || empty ($_POST['dbname'])) {
		web_line($langop_err_dbs);
		$input_fail = 1;
	}
	if (empty ($_POST['dbpass'])) {
		web_line($langop_note_pwd);
	}
	if (empty ($usrname)) {
		web_line($langop_err_adminname);
		$input_fail = 1;
	}
	if (empty ($pass) || empty ($pass2)) {
		web_line($langop_err_adminpwd);
		$input_fail = 1;
	}
	if ($pass != $pass2) {
		web_line($langop_err_admpwsmtch);
		$input_fail = 1;
	}
	if (empty ($salt)) {
		$salt = 'as';
	}
	if ($input_fail == 1) {
echo <<<EOF
		</p>
	</div>
</body>
</html>
EOF;
		exit;
	}
	web_line();


	// Test database connection before making files
	$dbconn = @mysql_connect ($_POST['dbhost'], $_POST['dbuser'], $_POST['dbpass']);
	if (!$dbconn) {
		web_line('ERROR:  Could not connect to MySQL database with supplied information.');
		web_line('DB:  '.mysql_error());
		exit();
	}
	$mySQLDB = @mysql_select_db ($_POST['dbname']);
	if (!$mySQLDB) {
		mysql_close ($dbconn);
		web_line('ERROR:  MySQL connection successful, but cannot access database named &ldquo;'.$_POST['dbname'].'&rdquo;');
		exit();
	}


	// Create a database connection file from POST data.
$db_configuration = <<<EOF
<?php // Include only

	\$dbhost = '{$_POST['dbhost']}';
	\$dbuser = '{$_POST['dbuser']}';
	\$dbpass = '{$_POST['dbpass']}';
	\$dbname = '{$_POST['dbname']}';
	\$OekakiPoteto_Prefix = '{$_POST['dbprefix']}';
	\$OekakiPoteto_MemberPrefix = '{$_POST['OekakiPoteto_MemberPrefix']}';

	\$dbconn = mysql_connect(\$dbhost, \$dbuser, \$dbpass) or die('Could not connect to the MySQL database.');
	\$mySQLDB = mysql_select_db(\$dbname);

?>
EOF;
//<?

	// Create a configuration file from POST data.
	// Verify paths
	$op_url  = strip_path($_POST['op_url']);
	$op_pics = strip_path($_POST['op_pics']);
	$avatar_folder = strip_path($_POST['avatar_folder']);

	if (empty ($op_pics)) {
		$op_pics = 'pictures';
	}
	if (empty ($avatar_folder)) {
		$avatar_folder = 'avatars';
	}
	$_POST['op_pre']      = strip_path($_POST['op_pre']);
	$_POST['preview_img'] = strip_path($_POST['preview_img']);
	$_POST['xxx_img']    = strip_path($_POST['xxx_img']);

	// #@!*'n magic quotes!
	$the_title = htmlspecialchars (str_replace('\\"', '&quot;', $_POST['op_title']), ENT_NOQUOTES);
	$the_author = htmlspecialchars (str_replace('\\"', '&quot;', $_POST['op_author']), ENT_NOQUOTES);
	$the_preview = htmlspecialchars (str_replace('\\"', '&quot;', $_POST['preview_title']), ENT_NOQUOTES);

	// Other verification
	$reg_draw   = 'no';
	$reg_anim   = 'no';
	$reg_upload = 'no';
	if (!empty ($_POST['reg_draw']))   $reg_draw = 'yes';
	if (!empty ($_POST['reg_anim']))   $reg_anim = 'yes';
	if (!empty ($_POST['reg_upload'])) $reg_upload = 'yes';

	// Fix e-mails
	$op_email = trim ($_POST['op_email']);
	$admin_email = trim ($_POST['admin_email']);
	if (empty ($admin_email)) {
		$admin_email = $op_email;
	}

	// Other verification
	$reg_draw   = 'no';
	$reg_anim   = 'no';
	$reg_upload = 'no';
	if (!empty ($_POST['reg_draw']))   $reg_draw = 'yes';
	if (!empty ($_POST['reg_anim']))   $reg_anim = 'yes';
	if (!empty ($_POST['reg_upload'])) $reg_upload = 'yes';

	// Verify min/max values
	{
		$verify     = array ('pic_store', 'pic_pages', 'menu_pages', 'def_x', 'def_y', 'canvas_x', 'canvas_y', 'min_x', 'min_y', 'canvas_a', 'max_anim', 'thumb_bytes', 'thumb_t', 'thumb_r', 'max_pic', 'avatar_x', 'avatar_y', 'safety_storetime');
		$verify_min = array (10, 1, 5, 50, 50, 50, 50, 50, 50, 2500, 1000, 25000, 50, 50, 100000, 1, 1, 1);
		$verify_max = array (10000, 50, 500, 10000, 10000, 10000, 10000, 500, 500, 100000000, 1000000, 15000000, 500, 1000, 2000000, 150, 150, 100);

		$i = 0;
		foreach ($verify as $name) {
			if ($_POST[$name] < $verify_min[$i]) $_POST[$name] = $verify_min[$i];
			if ($_POST[$name] > $verify_max[$i]) $_POST[$name] = $verify_max[$i];
			$i++;
		}
	}

	$main_configuration = <<<EOF
<?php // Include only
	\$cfg = array();
	\$cfg['version'] = '1.3.0';

	\$cfg['op_title']  = '$the_title';
	\$cfg['op_author'] = '$the_author';
	\$cfg['op_adult']  = '{$_POST['op_adult']}';
	\$cfg['op_email']  = '{$op_email}';
	\$cfg['op_url']    = '{$op_url}';

	\$cfg['salt']    = '{$salt}';
	\$cfg['op_pics'] = '{$op_pics}';
	\$cfg['op_pre']  = '{$_POST['op_pre']}';

	\$cfg['kill_user']   = '{$_POST['kill_user']}';
	\$cfg['kill_reg']    = '15';
	\$cfg['draw_immune'] = '{$_POST['draw_immune']}';
	\$cfg['approval']    = '{$_POST['approval']}';
	\$cfg['require_art'] = '{$_POST['require_art']}';
	\$cfg['guest_post']  = '{$_POST['guest_post']}';
	\$cfg['guest_draw']  = 'no'; //WIP
	\$cfg['guest_adult'] = '{$_POST['guest_adult']}';
	\$cfg['humanity_post'] = 'yes';
	\$cfg['reg_draw']    = '$reg_draw';
	\$cfg['reg_anim']    = '$reg_anim';
	\$cfg['reg_upload']  = '$reg_upload';
	\$cfg['reg_rules']   = '{$_POST['reg_rules']}';

	\$cfg['language'] = $language;
	\$cfg['template'] = '{$_POST['template']}';
	\$cfg['tpl_path'] = 'templates';
	\$cfg['res_path'] = 'resource';

	\$cfg['pic_store']  = '{$_POST['pic_store']}';
	\$cfg['pic_pages']  = '{$_POST['pic_pages']}';
	\$cfg['menu_pages'] = '{$_POST['menu_pages']}';
	\$cfg['pic_limit']      = '2';  //WIP
	\$cfg['pic_limit_time'] = '24'; //WIP

	\$cfg['porn_img']      = '{$_POST['xxx_img']}';
	\$cfg['preview_img']   = '{$_POST['preview_img']}';
	\$cfg['preview_title'] = '{$the_preview}';
	\$cfg['def_x']    = '{$_POST['def_x']}';
	\$cfg['def_y']    = '{$_POST['def_y']}';
	\$cfg['canvas_x'] = '{$_POST['canvas_x']}';
	\$cfg['canvas_y'] = '{$_POST['canvas_y']}';
	\$cfg['min_x']    = '{$_POST['min_x']}';
	\$cfg['min_y']    = '{$_POST['min_y']}';
	\$cfg['canvas_a'] = '{$_POST['canvas_a']}';
	\$cfg['max_anim'] = '{$_POST['max_anim']}';
	\$cfg['max_pic']  = '{$_POST['max_pic']}';

	\$cfg['use_thumb']   = '{$_POST['use_thumb']}';
	\$cfg['force_thumb'] = '{$_POST['force_thumb']}';
	\$cfg['thumb_bytes'] = '{$_POST['thumb_bytes']}';
	\$cfg['thumb_t']     = '{$_POST['thumb_t']}';
	\$cfg['thumb_r']     = '{$_POST['thumb_r']}';
	\$cfg['thumb_jpg']   = '75';

	\$cfg['use_mailbox'] = '{$_POST['use_mailbox']}';

	\$cfg['use_chat']   = '{$_POST['use_chat']}';
	\$cfg['chat_max']   = '{$_POST['chat_max']}';
	\$cfg['chat_pages'] = '{$_POST['chat_pages']}';

	\$cfg['smilies'] = '{$_POST['smilies']}';

	\$cfg['use_avatars']   = '{$_POST['use_avatars']}';
	\$cfg['use_c_avatars'] = '{$_POST['use_c_avatars']}';
	\$cfg['avatar_folder'] = '{$avatar_folder}';
	\$cfg['avatar_x'] = '{$_POST['avatar_x']}';
	\$cfg['avatar_y'] = '{$_POST['avatar_y']}';

	\$cfg['public_retouch']   = '{$_POST['public_retouch']}';
	\$cfg['safety_storetime'] = '{$_POST['safety_storetime']}';
	\$cfg['safety_saves']     = '{$_POST['safety_saves']}';
	\$cfg['self_bump']        = '{$_POST['self_bump']}';
?>
EOF;
//<?


	// Write the config files
	$fp = @fopen ('dbconn.php', 'w');
	if ($fp) {
		fwrite ($fp, $db_configuration);
		fclose ($fp);
		web_line($langop_msg_dbsefile);
	} else {
		web_line($langop_err_permis);
echo <<<EOF
		</p>
	</div>
</body>
</html>
EOF;
//<?
		exit;
	}


	$fp = @fopen ('config.php', 'w');
	if ($fp) {
		fwrite ($fp, $main_configuration);
		fclose ($fp);
		web_line($langop_wrconfig);
	} else {
echo <<<EOF
			$langop_err_wrconfig
		</p>
	</div>
</body>
</html>
EOF;
//<?
		exit;
	}

	web_line();


	/* Create specified directories with their respective permissions */
	if (! file_exists ($op_pics)) {
		if (! @mkdir ($op_pics, 0755)) {
			web_line($langop_err_cfolder.'<em>'.$op_pics.'</em>');
		}
	}
	if (! is_writable ($op_pics)) {
		web_line($langop_err_folder.' <em>'.$op_pics.'</em> '.$langop_err_folderlocked);
	}
	if (! file_exists ($avatar_folder)) {
		if (! @mkdir ($avatar_folder, 0755)) {
			web_line($langop_err_cfolder.' <em>'.$avatar_folder.'</em>');
		}
	}
	if (! is_writable ($avatar_folder)) {
		web_line($langop_err_folder.' <em>'.$avatar_folder.'</em> '.$langop_err_folderlocked);
	}


	/* Create base resource files */
	$new_files = array (
		'banner.php' => '',
		'hosts.txt' => '',
		'ips.txt' => '',
		'notice.php' => '',
		'rules.php' => "<p>\n".$langop_netique."\n</p>"
	);
	$nf_error = 0;
	foreach ($new_files as $file_name => $file_data) {
		$status = make_new_file('resource/'.$file_name, $file_data);
		if (!$status)
			$nf_error++;
	}
	if ($nf_error) {
echo <<<EOF
			$langop_err_fcreate
		</p>
	</div>
</body>
</html>
EOF;
//<?
		exit;
	}

	web_line($langop_write_basefile);
	web_line();


	/* Insert the fields into the database */
	web_line($langop_startsetdb);

	include('config.php');

	$passenc = crypt($pass, $salt);

	if ($debug == 0) {
		{
			// Oekaki v1.0.0
			$sql = "CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekaki` (ID int(11) NOT NULL auto_increment, usrname varchar(255) NOT NULL default '', usrpass text DEFAULT '', usrflags varchar(10) default 'G', email varchar(255) default NULL, name varchar(25) default NULL, comment text, url text, aim varchar(30) default NULL, icq varchar(20) default NULL, urltitle text, joindate date NOT NULL default '0000-00-00', lastlogin datetime NOT NULL default '0000-00-00 00:00:00', MSN text, Yahoo text, IRCNick text, IRCServer text, location text, piccount int(11) NOT NULL default '0', IRCchan text, templatesel varchar(255) NOT NULL DEFAULT '', commcount int(11) NOT NULL DEFAULT '0', age text, gender text, picview tinyint(11) NOT NULL default '0', language VARCHAR(32) DEFAULT '', ";

			// Oekaki v1.1.0
			$sql .= "thumbview TINYINT NOT NULL DEFAULT 0, screensize MEDIUMINT NOT NULL DEFAULT 800, ";

			// Oekaki v1.2.0
			$sql .= "rank TINYINT NOT NULL DEFAULT 0, ";

			// Oekaki v1.3.0
			$sql .= "avatar VARCHAR(128) NOT NULL DEFAULT '', ";

			// Set info
			$sql .= "PRIMARY KEY (ID), UNIQUE KEY usrname (usrname)) TYPE=MyISAM";
			$result = mysql_query ($sql);
			sql_check($result, 'members');
		}

		$sqlstr = "INSERT INTO {$OekakiPoteto_MemberPrefix}oekaki (usrname, usrpass, usrflags, email, name, comment, joindate, language, rank) VALUES ('$usrname', '$passenc', 'GDMIU', '{$admin_email}', 'Administrator', 'Administrator Account', CURDATE(), 'english', 9)";
		$result = mysql_query ($sqlstr);
		sql_check($result, 'admin');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakichat` (ChatID int(11) NOT NULL auto_increment, usrname varchar(255) NOT NULL default '', comment tinytext NOT NULL DEFAULT '', posttime timestamp(14) NOT NULL, hostname text NOT NULL DEFAULT '', email varchar(255) default NULL, url text DEFAULT '', IP text NOT NULL DEFAULT '', postname varchar(50) NOT NULL default '', PRIMARY KEY  (ChatID)) TYPE=MyISAM");
		sql_check($result, 'chat');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_Prefix}oekakicmt` (ID_3 int(11) NOT NULL auto_increment, PIC_ID varchar(11) NOT NULL default '', usrname varchar(255) NOT NULL default '', comment text NOT NULL DEFAULT '', postdate datetime default NULL, hostname text NOT NULL DEFAULT '', email varchar(255) default NULL, url text DEFAULT '', IP text NOT NULL DEFAULT '', postname varchar(50) NOT NULL default '', PRIMARY KEY  (ID_3), KEY PIC_ID (PIC_ID)) TYPE=MyISAM"); 
		sql_check($result, 'comment');

		{
			// OekakiData v1.0.0
			$sql = "CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_Prefix}oekakidta` (ID_2 int(11) NOT NULL auto_increment, PIC_ID int(11) NOT NULL default 0, usrname varchar(255) NOT NULL default '', comment text NOT NULL DEFAULT '', postdate datetime NOT NULL default '0000-00-00 00:00:00', hostname text NOT NULL DEFAULT '', email varchar(255) default NULL,  url text DEFAULT '', IP text NOT NULL DEFAULT '', title varchar(255) default NULL, lastcmt datetime NOT NULL default '0000-00-00 00:00:00', adult tinyint(2) NOT NULL default '0', edittime int(20) unsigned default NULL, animation tinyint(2) default '0', datatype tinyint(2) default '0', archive tinyint(2) NOT NULL default '0', postlock tinyint(4) NOT NULL default '0', ";

			// OekakiData v1.1.0
			$sql .= "threadlock TINYINT NOT NULL DEFAULT 0, px MEDIUMINT DEFAULT 0, py MEDIUMINT DEFAULT 0, ptype VARCHAR(4), ttype VARCHAR(4), rtype VARCHAR(4), usethumb TINYINT NOT NULL DEFAULT 0, ";

			// OekakiData v1.2.0
			$sql .= "password text NOT NULL DEFAULT '', ";

			// OekakiData v1.3.0
			$sql .= "origart VARCHAR(255) NOT NULL DEFAULT '', ";

			// Set info
			$sql .= "PRIMARY KEY (ID_2), UNIQUE KEY PIC_ID (PIC_ID)) TYPE=MyISAM";
			$result = mysql_query ($sql);
			sql_check($result, 'data');
		}

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakionline` (OID BIGINT(255) NOT NULL auto_increment, onlineusr varchar(100) NOT NULL default '', onlinetime timestamp(14) NOT NULL, onlineIP text NOT NULL DEFAULT '', locale varchar(30) default NULL, onlineboard text NOT NULL DEFAULT '', PRIMARY KEY  (OID), UNIQUE KEY onlineusr (onlineusr)) TYPE=MyISAM");
		sql_check($result, 'online');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakimailbox` (MID int(11) NOT NULL auto_increment, sender varchar(255) NOT NULL default '', reciever varchar(255) NOT NULL default '', subject text NOT NULL DEFAULT '', body longtext NOT NULL DEFAULT '', mstatus smallint(10) NOT NULL default '0', senddate datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (MID), KEY sender(sender), KEY reciever (reciever)) TYPE=MyISAM"); 
		sql_check($result, 'mailbox');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_Prefix}oekakimisc` (MiscID int(11) NOT NULL auto_increment, miscname varchar(255) NOT NULL default '', miscvalue bigint(255) default '0' NOT NULL, miscstring VARCHAR(14), PRIMARY KEY (MiscID), KEY miscname (miscname)) TYPE=MyISAM");
		sql_check($result, 'misc');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakichatmod` (usrname varchar(255) NOT NULL default '',  command varchar(32) NOT NULL default 'MESSAGE', comment tinytext NOT NULL DEFAULT '', posttime timestamp(14) NOT NULL, hostname text NOT NULL DEFAULT '', email varchar(255) default NULL, url text DEFAULT '',  IP text NOT NULL DEFAULT '', postname varchar(50) NOT NULL default '', PRIMARY KEY (posttime)) TYPE=MyISAM"); 
		sql_check($result, 'chat_mod');

		$result = mysql_query ("CREATE TABLE IF NOT EXISTS `{$OekakiPoteto_MemberPrefix}oekakichatmodusers` (usrname varchar(255) NOT NULL,  lastmessage timestamp(14) NOT NULL, afk ENUM('no','yes') NOT NULL default 'no', PRIMARY KEY (usrname)) TYPE=MyISAM");
		sql_check($result, 'chat_mod_users');

		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakimisc VALUES (1, 'piccount', 0, NULL)");
		sql_check($result, 'piccount');
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakimisc VALUES (2, 'dbversion', 0, '1.3.0')");
		sql_check($result, 'dbversion');
	}

	mysql_close ($dbconn);

	web_line($langop_finishsetdb);

echo <<<EOF
		</p>
		<hr />

		<p class="infonote">
			$langop_noanyerrors <br />
			<br />
			$langop_anotherboarderr <br />
			<br />
			$langop_clickbuttonfinal
		</p>

		<form action="index.php" method="post">
			<input name="action" type="hidden" value="secure" />
			<input name="submit" type="submit" value="$langop_secinst" />
		</form>
	</div>

</body>
</html>
EOF;
//<?

	exit;
}



// ===================================================================
// No mode specified.  Output installer.
//

// Guess URL for BBS
$url_guess = $_SERVER['SERVER_NAME'].str_replace ('\\', '/', dirname ($_SERVER['PATH_INFO']));

// Test for correct folder permissions
	if (! (is_writable ('resource') && is_writable ('templates'))) {
		// Nope.
echo <<<EOF
	<h2 class="header">
		$langop_err_install
	</h2>
	<div class="infotable">
		<p>
		$langop_err_temp_resource
		</p>
	</div>

	</body>
	</html>
EOF;
		exit;
	}

//Initialize language
	
if ($handle = opendir('language')) {
	/* This is the correct way to loop over the directory. */
	while (false !== ($file = readdir($handle))) {
		$f_name = substr ($file, 0, -4);
		if (substr ($file,-4) == '.php') {
		$langopts.='<option value="'.$f_name.'"';
			if($f_name==$language) $langopts.= ' selected';
			$langopts.='>'.$f_name.'</option>';
		}
	}
closedir($handle);
}


// Begin main install page
echo <<<EOF
	<h1 class="title">
		$langop_wac_inst
	</h1>

	<hr />
	
	<form name="form1" method="post" action="install.php">

	<h2 class="header">
		$langop_cpanel_deflang
	</h2>

	<div class="infotable">
		<p class="infonote">
		<font size="-1" face="Arial, Helvetica, sans-serif">
		&nbsp;
		<select name="langs" id="select8" onchange="this.form.submit()">
		$langopts
		</select>
		</font>
		<br />

		</p>
	</div>
	<br />

	<h2 class="header">
		$langop_inst_note
	</h2>

	<div class="infotable">
		<p class="infonote">
			$langop_assist_install</a>.
		</p>
	</div>
	<br />



		<h2 class="header">
			$langop_install_information
		</h2>

		<div class="infotable">
			<p class="infonote">
				$langop_mysqldb_wact
			</p>

			<table class="infomain">
			
			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbhostname
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbhost" size="40" style="font-color:red;" value="localhost" />
			</td>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbname
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbname" size="40" value="$dbname" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbusername
			</td>
			<td>
				<input type="text" name="dbuser" size="40" value="$dbuser" />
			<td class="infoenter" valign="top">
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbpass
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="dbpass" size="40" />
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_dbtablepref
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbprefix" size="40" value="op_" />

				<p class="subtext">
					$langop_multiboardpref
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_memberpref
			</td>
			<td class="infoenter" valign="top">
				<input name="OekakiPoteto_MemberPrefix" type="text" id="OekakiPoteto_MemberPrefix" value="op_" size="40" />

				<p class="subtext">
					$langop_instalmulti
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_salt
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="salt" size="40" value="As" />

				<p class="subtext">
					$langop_install_saltsub
				</p>
			</td>
			</tr>
			</table>

			<p class="infonote" style="text-align: center">
				$langop_clickhereto <a href="install.php?mode=del&langs={$language}">$langop_uninstexist</a>. $langop_confwreq
			</p>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispreg
		</h2>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_opurl
			</td>
			<td class="infoenter" valign="top">
				<input name="op_url" type="text" value="http://{$url_guess}" size="40" />
				<p class="subtext">
					$langop_guessregis
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_email
			</td>
			<td class="infoenter" valign="top">
				<input name="op_email" type="text" size="40" />

				<p class="subtext">
					$langop_install_emailsub
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_admininfo
		</h2>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_login
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="usrname" size="40" value="$usrname" />
			</td>
			</tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_password
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="pass" size="40" />
			</td>
			</tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_eprofile_repass
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="pass2" size="40" />
			</td>
			</tr>


			<tr>
				<td class="infoask" valign="top">
				$langop_emaildesc
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="admin_email" size="40" />
			</td>
			</tr>
			</table>
		</div>
		<br />


		<h2 class="header">
			$langop_install_general
		</h2>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_picpref
			</td>
			<td class="infoenter" valign="top">
				<input name="op_pre" type="text" value="OP_" size="40" />

				<p class="subtext">
				$langop_picprefexp
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_picdir
			</td>
			<td class="infoenter" valign="top">
				<input name="op_pics" type="text" value="pictures" size="40" />

				<p class="subtext">
					$langop_install_picdirsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_picstore
			</td>
			<td class="infoenter" valign="top">
				<input name="pic_store" type="text" value="200" size="40" />

				<p class="subtext">
					$langop_install_picstoresub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_allowppicture
			</td>
			<td class="infoenter" valign="top">
				<select name="public_retouch" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
				<p class="subtext">
					$langop_ppmsgrtouch
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_allowsafesave
			</td>
			<td class="infoenter" valign="top">
				<select name="safety_saves" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
				<p class="subtext">
					$langop_safesaveexp
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_savestorage
			</td>
			<td class="infoenter" valign="top">
				<input name="safety_storetime" type="text" value="10" size="5" class="txtinput" /> $langop_word_days

				<p class="subtext">
					$langop_safetydays
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_reg
		</h2>

		<div class="infotable">
			<table>
			<tr>
			<td class="infoask" valign="top">
				$langop_install_adel
			</td>
			<td class="infoenter" valign="top">
				<input name="kill_user" type="text" value="-1" size="6" />
				$langop_install_adelsub2

				<p class="subtext">
					$langop_install_adelsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_autoimune
			</td>
			<td class="infoenter" valign="top">
				<select name="draw_immune" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_autoimune_exp
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_showrulereg
			</td>
			<td class="infoenter" valign="top">
				<select name="reg_rules" class="multiline">
					<option value="yes">$langop_word_yes</option>
					<option value="no" selected>$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_showruleregexp
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_gallow
			</td>
			<td class="infoenter" valign="top">
				<select name="guest_post">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_install_gallowsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Require Art -->
			<tr>
			<td class="infoask" valign="top">
				$langop_requireartsub
			</td>
			<td class="infoenter" valign="top">
				<select name="require_art">
					<option value="yes">$langop_word_yes</option>
					<option value="no" selected>$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_requireartsubyes<br />
					$langop_requireartsubno
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_rapproval
			</td>
			<td class="infoenter" valign="top">
				<select name="approval">
					<option value="yes" selected> $langop_word_yes </option>
					<option value="no"> $langop_word_no </option>
					<option value="force"> $langop_forceactivate </option>
				</select>

				<p class="subtext">
					$langop_activateyes <br />
					$langop_activeno
					<b> $langop_activateforced </b>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_defaultpermis
			</td>
			<td class="infoenter" valign="top">
				<input name="reg_draw" type="checkbox" value="D" checked />$langop_type_daccess<br />
				<input name="reg_anim" type="checkbox" value="A" checked />$langop_type_aaccess<br />
				<input name="reg_upload" type="checkbox" value="U" />$langop_type_uaccess
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Self Bump -->
			<tr>
			<td class="infoask" valign="top">
				$langop_bumpretouch
			</td>
			<td class="infoenter" valign="top">
				<select name="self_bump" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispgen
		</h2>

		<div class="infotable">
			<table class="infomain">

			<!-- BBS Title -->
			<tr>
			<td class="infoask" valign="top">
				$langop_install_title2
			</td>
			<td class="infoenter" valign="top">
				<input name="op_title" type="text" value="OekakiPoteto BBS" size="40" />

				<p class="subtext">
					$langop_install_title2sub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- BBS Author -->
			<tr>
			<td class="infoask" valign="top">
				$langop_authorname
			</td>
			<td class="infoenter" valign="top">
				<input name="op_author" type="text" value="" size="40" />

				<p class="subtext">
					$langop_bbsowner
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_adultrbbs
			</td>
			<td class="infoenter" valign="top">
				<select name="op_adult">
					<option value="yes">$langop_word_yes</option>
					<option value="no" selected>$langop_word_no</option>
				</select>
				<br />

				<p class="subtext">
					$langop_adultrbbsdesc<br />
					$langop_adultrbbsnote
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_allowpron
			</td>
			<td class="infoenter" valign="top">
				<select name="guest_adult" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_allowpronyes<br />
					$langop_allowpronno
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_deftem
			</td>
			<td class="infoenter" valign="top">
				<select name="template" id="template">

EOF;
//<?

if ($handle = opendir('templates')) {
	/* This is the correct way to loop over the directory. */
	while (false !== ($file = readdir($handle))) {
		if (substr($file,-4) == '.php'){
			if (strtolower(substr($file,0,-4)) == 'banana') {
?>
				<option value="<?=substr($file,0,-4)?>" selected><?= substr($file, 0, -4); ?></option>
<?
			} else {
?>
				<option value="<?=substr($file,0,-4)?>"><?= substr($file, 0, -4); ?></option>
<?
			}
		}
	}
	closedir($handle);
}

echo <<<EOF
				</select>

				<p class="subtext">
					$langop_install_deftemsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per index page -->
			<tr>
			<td class="infoask" valign="top">
				$langop_maxpiconind
			</td>
			<td class="infoenter" valign="top">
				<input name="pic_pages" type="text" value="10" size="40" />

				<p class="subtext">
					$langop_maxpicinddesc
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per other page -->
			<tr>
			<td class="infoask" valign="top">
				$langop_menuentries
			</td>
			<td class="infoenter" valign="top">
				<input name="menu_pages" type="text" value="25" size="40" />

				<p class="subtext">
					$langop_menuentriesdesc
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Smilies -->
			<tr>
			<td class="infoask" valign="top">
				$langop_usesmilies
			</td>
			<td class="infoenter" valign="top">
				<select name="smilies" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
				<p class="subtext">
					$langop_usesmiliedesc
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Avatars -->
		<h2 class="header">
			$langop_word_avatars
		</h2>

		<div class="infotable">
			<table class="infomain">
			<!-- Enable -->
			<tr>
			<td class="infoask" valign="top">
				$langop_enableavata
			</td>
			<td class="infoenter" valign="top">
				<select name="use_avatars" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_allowavatar
			</td>
			<td class="infoenter" valign="top">
				<select name="use_c_avatars" class="multiline">
					<option value="no" selected>$langop_word_no</option>
					<option value="yes">$langop_word_yes</option>
				</select>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_AvatarStore
			</td>
			<td class="infoenter" valign="top">
				<input name="avatar_folder" type="text" class="textinput" size="60" value="avatars" />

				<p class="subtext">
					$langop_changemulti !<br />
					$langop_changemultidesc
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_maxavatar
			</td>
			<td class="infoenter" valign="top">
				<input name="avatar_x" type="text" value="50" size="6" class="txtinput" />
				&times;
				<input name="avatar_y" type="text" value="50" size="6" class="txtinput" />

				<p class="subtext">
					$langop_maxavatardesc
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_appletset
		</h2>

		<div class="infotable">
			<table class="infomain">
			<!-- Canvas Defaults -->
			<tr>
			<td class="infoask" valign="top">
				$langop_cavasize
			</td>
			<td class="infoenter" valign="top">
				<input name="def_x" type="text" value="300" size="6" />
				&times;
				<input name="def_y" type="text" value="300" size="6" />

				<p class="subtext">
					$langop_defcanvasize
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Min -->
			<tr>
			<td class="infoask" valign="top">
				$langop_mincanvasize
			</td>
			<td class="infoenter" valign="top">
				<input name="min_x" type="text" value="50" size="6" />
				&times;
				<input name="min_y" type="text" value="50" size="6" />

				<p class="subtext">
					$langop_mincanvasizedesc
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Max -->
			<tr>
			<td class="infoask" valign="top">
				$langop_maxcanvasize
			</td>
			<td class="infoenter" valign="top">
				<input name="canvas_x" type="text" value="500" size="6" />
				&times;
				<input name="canvas_y" type="text" value="500" size="6" />

				<p class="subtext">
					$langop_maxcanvasizedesc.<br />
					$langop_maxcanvasizedesc2 !
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Anim -->
			<tr>
			<td class="infoask" valign="top">
				$langop_install_animax
			</td>
			<td class="infoenter" valign="top">
				<input name="max_anim" type="text" value="500000" size="40" />
				$langop_install_bytes

				<p class="subtext">
					$langop_install_animaxsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Upload -->
			<tr>
			<td class="infoask" valign="top">
				$langop_maxfilesize
			</td>
			<td class="infoenter" valign="top">
				<input name="max_pic" type="text" value="500000" size="40" class="txtinput" />
				$langop_install_bytes

				<p class="subtext">
					$langop_maxupfileexp<br />
					$langop_maxupfileexp2
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Area
			<tr>
			<td class="infoask" valign="top">
				Maximum Canvas Area
			</td>
			<td class="infoenter" valign="top">
				<input name="canvas_a" type="text" value="250000" size="40" />

				<p class="subtext">
					This setting allows for large, panoramic canvases without affecting bandwidth.  Example: 1000 &times; 250 uses the same bandwidth as 500 &times 500, while allowing the max width and height to be 1000 pixels each.  However, a 1000 &times 1000 canvas would not be allowed.  Default is 250000 pixels.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>
			-->
			<input name="canvas_a" type="hidden" value="250000" />



			<!-- Preview -->
			<tr>
			<td class="infoask" valign="top">
				$langop_canvasprev
			</td>
			<td class="infoenter" valign="top">
				<input name="preview_img" type="text" value="preview.png" size="40" />

				<p class="subtext">
					$langop_canvasprevexp
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Preview Title -->
			<tr>
			<td class="infoask" valign="top">
				$langop_pviewtitle
			</td>
			<td class="infoenter" valign="top">
				<input name="preview_title" type="text" value="Image Preview" size="40" />

				<p class="subtext">
					$langop_titleprevwi
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pr0n Image -->
			<tr>
			<td class="infoask" valign="top">
				$langop_pron
			</td>
			<td class="infoenter" valign="top">
				<input name="xxx_img" type="text" value="pr0n.png" size="40" class="txtinput" />

				<p class="subtext">
					$langop_prondesc
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Mailbox -->
		<h2 class="header">
			$langop_word_display - $langop_word_mailbox
		</h2>

		<div class="infotable">
			<table class="infomain">

			<!-- Enable Mailbox -->
			<tr>
			<td class="infoask" valign="top">
				$langop_word_enable $langop_word_mailbox
			</td>
			<td class="infoenter" valign="top">
				<select name="use_mailbox" class="txtinput">
					<option value="yes" selected>$langop_word_yes ($langop_word_recommended)</option>
					<option value="no">$langop_word_no</option>
				</select>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispchat
		</h2>

		<div class="infotable">
			<table class="infomain">

			<tr>
			<td class="infoask" valign="top">
				$langop_enablechat
			</td>
			<td class="infoenter" valign="top">
				<select name="use_chat">
					<option value="no" selected>$langop_word_no ($langop_word_recommended)</option>
					<option value="yes">$langop_word_yes</option>
				</select>

				<p class="subtext">
					$langop_chatnote
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>

			<tr>
			<td class="infoask" valign="top">
				$langop_install_displinesmax
			</td>
			<td class="infoenter" valign="top">
				<input name="chat_max" type="text" value="1000" size="40" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_displines
			</td>
			<td class="infoenter" valign="top">
				<input name="chat_pages" type="text" value="15" size="40" />
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Compression Settings -->
		<h2 class="header">
			$langop_compress_title
		</h2>

		<div class="infotable">
			<p class="infonote">

EOF;
if (!extension_loaded ('gd')) {
echo <<<EOF
				$langop_err_nogdlib<br />
				<br />

EOF;
}
echo <<<EOF
				$langop_thumbmodes<br />
				<br />
				$langop_thumbmodesexp<br />
				<br />
				$langop_thumbmodesexp2
			</p>

			<table class="infomain">
			<!-- Layout mode -->
			<tr>
			<td class="infoask" valign="top">
				$langop_defthumbmode
			</td>
			<td class="infoenter" valign="top">
				<select name="use_thumb" class="multiline">
					<option value="0">$langop_word_none</option>
					<option value="1">$langop_word_layout</option>
					<option value="2" selected>$langop_word_defscale</option>
					<option value="3">$langop_word_uniformity</option>
				</select>

				<p class="subtext">
					$langop_optiontip
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Force Layout -->
			<tr>
			<td class="infoask" valign="top">
				$langop_forcedefthumb
			</td>
			<td class="infoenter" valign="top">
				<select name="force_thumb" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_forcethumbdesc
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Small Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				$langop_smallthumb
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_t" type="text" value="120" size="10" class="txtinput" />

				<p class="subtext">
					$langop_smallthumbdesc
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Large Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				$langop_largethumb
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_r" type="text" value="250" size="10" class="txtinput" />

				<p class="subtext">
					$langop_largethumbdesc
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Thumbnail Bytes -->
			<tr>
			<td class="infoask" valign="top">
				$langop_thumbnailfilesize
			</td>
			<td class="infoenter" valign="top">
				<input name="thumb_bytes" type="text" value="100000" size="10" class="txtinput" />
				$langop_install_bytes

				<p class="subtext">
					$langop_thumbsizedesc
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />


		<h2 class="header">
			$langop_finalinstal
		</h2>

		<div class="infotable">
			<p class="infonote">
				<strong>$langop_install_TOS</strong>
			</p>

			<p style="text-align: center;">
				<input type="hidden" name="action" value="process" />
				<input type="submit" name="Submit" value="$langop_word_submit" />
			</p>
		</div>
	</form>
	<br />


	<div id="footer">
		OekakiPoteto 5.x by <a href="http://www.suteki.nu">RanmaGuy</a> and <a href="http://www.cellosoft.com">Marcello</a><br />
		Wacintaki Poteto 1.x modifications by <a href="http://www.NineChime.com/Wacintosh.htm">Waccoon</a>
EOF;
		if ($language != 'english') {
			echo "<br />\n		{$langop_language} translation by: {$langop_translator}<br />\n";
		}
echo <<<EOF

	</div>

</body>
</html>
EOF;
//<?

exit();

?>